Package weka.filters.unsupervised.attribute

# Class ChangeDateFormat

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.attribute.ChangeDateFormat

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `CapabilitiesIgnorer`, `CommandlineRunnable`, `OptionHandler`, `RevisionHandler`, `WeightedAttributesHandler`, `WeightedInstancesHandler`, `StreamableFilter`, `UnsupervisedFilter`

public class ChangeDateFormat extends Filter implements UnsupervisedFilter, StreamableFilter, OptionHandler, WeightedInstancesHandler, WeightedAttributesHandler
Changes the date format used by a date attribute. This is most useful for converting to a format with less precision, for example, from an absolute date to day of year, etc. This changes the format string, and changes the date values to those that would be parsed by the new format.

Valid options are:

     -C <col>
      Sets the attribute index (default last).

     -F <value index>
      Sets the output date format string (default corresponds to ISO-8601).

Version:
  $Revision: 14534 $
Author:
  Len Trigg
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ChangeDateFormat()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `attributeIndexTipText()`
  `String`
  `dateFormatTipText()`
  `String`
  `getAttributeIndex()`
  Gets the index of the attribute converted.
  `Capabilities`
  `getCapabilities()`
  Returns the Capabilities of this filter.
  `SimpleDateFormat`
  `getDateFormat()`
  Get the date format used in output.
  `String[]`
  `getOptions()`
  Gets the current settings of the filter.
  `String`
  `getRevision()`
  Returns the revision string.
  `String`
  `globalInfo()`
  Returns a string describing this filter
  `boolean`
  `input(Instance instance)`
  Input an instance for filtering.
  `Enumeration<Option>`
  `listOptions()`
  Returns an enumeration describing the available options
  `static void`
  `main(String[] argv)`
  Main method for testing this class.
  `void`
  `setAttributeIndex(String attIndex)`
  Sets the index of the attribute used.
  `void`
  `setDateFormat(String dateFormat)`
  Sets the output date format.
  `void`
  `setDateFormat(SimpleDateFormat dateFormat)`
  Sets the output date format.
  `boolean`
  `setInputFormat(Instances instanceInfo)`
  Sets the format of the input instances.
  `void`
  `setOptions(String[] options)`
  Parses a given list of options.

  ### Methods inherited from class weka.filters.Filter

  `batchFilterFile, batchFinished, debugTipText, doNotCheckCapabilitiesTipText, filterFile, getCapabilities, getCopyOfInputFormat, getDebug, getDoNotCheckCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, mayRemoveInstanceAfterFirstBatchDone, numPendingOutput, output, outputPeek, postExecution, preExecution, run, runFilter, setDebug, setDoNotCheckCapabilities, toString, useFilter, wekaStaticWrapper`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ChangeDateFormat

    public ChangeDateFormat()

- ## Method Details

  - ### globalInfo

    public String globalInfo()
    Returns a string describing this filter
    Returns:
      a description of the filter suitable for displaying in the explorer/experimenter gui

  - ### getCapabilities

    public Capabilities getCapabilities()
    Returns the Capabilities of this filter.
    Specified by:
      `getCapabilities` in interface `CapabilitiesHandler`
    Overrides:
      `getCapabilities` in class `Filter`
    Returns:
      the capabilities of this object
    See Also:
      - `Capabilities`

  - ### setInputFormat

    public boolean setInputFormat(Instances instanceInfo) throws Exception
    Sets the format of the input instances.
    Overrides:
      `setInputFormat` in class `Filter`
    Parameters:
      `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
    Returns:
      true if the outputFormat may be collected immediately
    Throws:
      `Exception` - if the input format can't be set successfully

  - ### input

    public boolean input(Instance instance) throws Exception
    Input an instance for filtering.
    Overrides:
      `input` in class `Filter`
    Parameters:
      `instance` - the input instance
    Returns:
      true if the filtered instance may now be collected with output().
    Throws:
      `Exception` - if the input format was not set or the date format cannot be parsed

  - ### listOptions

    public Enumeration<Option> listOptions()
    Returns an enumeration describing the available options
    Specified by:
      `listOptions` in interface `OptionHandler`
    Overrides:
      `listOptions` in class `Filter`
    Returns:
      an enumeration of all the available options

  - ### setOptions

    public void setOptions(String[] options) throws Exception
    Parses a given list of options.

    Valid options are:

         -C <col>
          Sets the attribute index (default last).

         -F <value index>
          Sets the output date format string (default corresponds to ISO-8601).

    Specified by:
      `setOptions` in interface `OptionHandler`
    Overrides:
      `setOptions` in class `Filter`
    Parameters:
      `options` - the list of options as an array of strings
    Throws:
      `Exception` - if an option is not supported

  - ### getOptions

    public String[] getOptions()
    Gets the current settings of the filter.
    Specified by:
      `getOptions` in interface `OptionHandler`
    Overrides:
      `getOptions` in class `Filter`
    Returns:
      an array of strings suitable for passing to setOptions

  - ### attributeIndexTipText

    public String attributeIndexTipText()
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getAttributeIndex

    public String getAttributeIndex()
    Gets the index of the attribute converted.
    Returns:
      the index of the attribute

  - ### setAttributeIndex

    public void setAttributeIndex(String attIndex)
    Sets the index of the attribute used.
    Parameters:
      `attIndex` - the index of the attribute

  - ### dateFormatTipText

    public String dateFormatTipText()
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getDateFormat

    public SimpleDateFormat getDateFormat()
    Get the date format used in output.
    Returns:
      the output date format.

  - ### setDateFormat

    public void setDateFormat(String dateFormat)
    Sets the output date format.
    Parameters:
      `dateFormat` - the output date format.

  - ### setDateFormat

    public void setDateFormat(SimpleDateFormat dateFormat)
    Sets the output date format.
    Parameters:
      `dateFormat` - the output date format.

  - ### getRevision

    public String getRevision()
    Returns the revision string.
    Specified by:
      `getRevision` in interface `RevisionHandler`
    Overrides:
      `getRevision` in class `Filter`
    Returns:
      the revision

  - ### main

    public static void main(String[] argv)
    Main method for testing this class.
    Parameters:
      `argv` - should contain arguments to the filter: use -h for help